#include <sys/time.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/sem.h>
#include "semaph.h"
#include "def.h"

#define BUFFSIZE  256


struct 	timeval ti;
struct 	timeval tf;
BUFFER	*buf[2];
int 	emptybuf_sem, fullbuf_sem;
char 	buff[BUFFSIZE];
long 	aux[4000][2];

int main(int argc,char *argv[])
{
//	struct timeval *tv;
	int 	i,fdes;
	char 	/*buff[BUFFSIZE],*/datos[BUFFSIZE];
        int 	size;
	int 	pipe1[2];
	pid_t 	pid;
	long 	tiempos[4000][4];
	
	FILE 	*fd;
//	BUFFER	*buf[2];
	int	shmid[2];
//	int 	emptybuf_sem, fullbuf_sem;

	//sem_t	*mutex;
        if (argc==1)
	{
		printf("Por defecto se transmiten 256 bytes\n");
		size=1;
	}
	else
	{	if (argc != 2)
		{	printf("Usar: edipc <tamao en KB>\n");
			exit(0);
		}
		size=((atoi(*++argv))*4);
		if ((size<1)||(size>4000))
		{	printf("Fuera de rango. Usar: edipc <1 a 1000 KB>\n");
			exit(0);
		}
	}
//	printf("%d paquetes\n",size);
  	
	for (i=0;i<BUFFSIZE;i++)
	{
		buff[i]='x';
//		printf ("%c",buff[i]);
	};
	for(i=0;i<4000;i++)	tiempos[i][0]=(i+1)*256;      //llena primera columna
        fd=fopen("datos.txt","w+");
	
// Transmisin por medio de PIPE.

	pipe(pipe1);	/* create pipe */
	
        if((pid=fork())<0){
        	printf("Fallo de Fork\n");
	        exit(0);}

	gettimeofday(&ti, NULL);
//     	printf ("El tiempo transcurre: %d",ti.tv_sec);
//	printf ("\n y microsegundos: %d\n",ti.tv_usec);
	if (pid==0)
	{	close(pipe1[1]);
		for (i=0;i<size;i++)
		{
			write(pipe1[0],buff,sizeof(buff));
		};
		exit(0);
	}

	else 	
	{	close (pipe1[0]);
		for (i=0;i<size;i++)
		{
			read (pipe1[1],datos,sizeof(datos));
                        gettimeofday(&tf,NULL);
//                      printf("test\n %d",tf.tv_usec);
			aux[i][0]=tf.tv_usec;
			aux[i][1]=tf.tv_sec;
		};
		//realizo el clculo afuera del bucle para alterar lo menos posible
		for (i=0;i<size;i++)           //la medicin de tiempo.
			tiempos[i][1]=((aux[i][0]-ti.tv_usec)+(aux[i][1]-ti.tv_sec));
        	waitpid(pid,0,NULL);
	}
	

// Transmisin por medio de FIFO entre procesos padre e hijo.

        unlink("mififo");
       	
	if (mkfifo("mififo", PERMS) < 0)
	{
        	printf("Fallo al crear fifo\n");
        	exit(0);
	}
       	fdes = open("mififo", O_RDWR);
 	
	if((pid=fork())<0)
	{
        	printf("Fallo de Fork\n");                       	
		exit(0);
	}
	gettimeofday(&ti,NULL);        	
	if (pid==0)
	{                            		
		for (i=0;i<size;i++)
		{
			write(fdes,buff,sizeof(buff));
		}
		exit(0);
	}

	else 			
	{	for (i=0;i<size;i++)
		{
			read(fdes,datos,sizeof(datos));
                        gettimeofday(&tf,NULL);
                        aux[i][0]=tf.tv_usec;
			aux[i][1]=tf.tv_sec;
		};
		for (i=0;i<size;i++)
			tiempos[i][2]=((aux[i][0]-ti.tv_usec)+(aux[i][1]-ti.tv_sec));

		waitpid(pid,0,NULL);
	}
       	close(fdes);
       	unlink("mififo");

// Transmisin por medio de memoria compartida.
	
	for (i = 0; i < 2; i++)
	{
        if ( (shmid[i] = shmget(SHMKEY + i, sizeof(BUFFER),PERMS | IPC_CREAT)) < 0)
		printf("server: can't get shared memory %d", i);
	if ( (buf[i] = (BUFFER *) shmat(shmid[i], (char *) 0, 0))== (BUFFER *) -1)
		printf("server: can't attach shared memory %d", i);
        };
	/*
   create the two semaphores
*/


	if ( (fullbuf_sem = sem_create(SEMKEY1, 0)) < 0)
		printf("server: can't create client semaphore");
	if ( (emptybuf_sem = sem_create(SEMKEY2, 1)) < 0)
		printf("server: can't create server semaphore");

	if((pid=fork())<0)
	{
       		printf("Fallo de Fork\n");
	        exit(0);
	}
	gettimeofday(&ti,NULL);
	
	if (pid==0)
	{
		for(i=0;i<((size/2)+1);i++)
			writer();
		exit(0);
	}

	else
	{	
		for(i=0;i<((size/2)+1);i++)
		{	
			reader(i);
		/*	gettimeofday(&tf,NULL);
  			aux[i][0]=tf.tv_usec;
			aux[i][1]=tf.tv_sec;*/
		};	
		for (i=0;i<size;i++)
			tiempos[i][3]=((aux[i][0]-ti.tv_usec)+(aux[i][1]-ti.tv_sec));

		
        	waitpid(pid,0,NULL);
	}
	
	if (shmdt(buf) < 0)
			perror("server: can't detach shared memory ");
	
	sem_close(emptybuf_sem);
	sem_close(fullbuf_sem);
	
	// Con todos los tiempos escribo el archivo datos.txt
	for (i=0;i<size;i++)
        	fprintf(fd,"\t%d\t%d\t%d\t%d\n",tiempos[i][0],tiempos[i][1],tiempos[i][2],tiempos[i][3]);
       	
	fclose(fd);
	system("gnuplot graph");	//gnuplot hace el resto.             	

	exit(0);
}


reader(int h)
{
	int j=0;
	

/*	sem_signal(emptybuf_sem);
	sem_signal(emptybuf_sem);
*/
	for (j=0;j<2;j++)
	{
		sem_wait(emptybuf_sem);
		buf[j]->size = read((int)buf[j],buf[j]->data, BSIZE);

		gettimeofday(&tf,NULL);
  		aux[j+2*h][0]=tf.tv_usec;
		aux[j+2*h][1]=tf.tv_sec;
		sem_signal(fullbuf_sem);
/*		if (buf[j]->size <=0)
			break;
*/		
	}
}

writer()
{
//	extern char buff[BUFFSIZE];
	int k=0;
	for (k=0;k<2;k++)
	{
                sem_wait(fullbuf_sem);
/*		if (buf[k]->size <=0)
                        break;
*/		write((int)buf[k], buff, sizeof(buff));
		sem_signal(emptybuf_sem);
		//k ^= 1;
        }
}
